% Funkcja implementujaca metode dopasowania blokowego.

function wczytaj(a),

switch a,
case 1,
   
   pathstary=pwd;
   [filename,pathname]=uigetfile('*.*','Wczytywanie pierwszej klatki', 250, 250);
   if pathname==0,
	   return
	end
	cd(pathname);
   kl1=imread(filename);
   id=findobj('type','axes');
   set(1,'currentaxes',id(2));
   imagesc(kl1);
   colormap gray;
   axis off;
   set(id(2),'userdata',kl1);
   [j,k]=size(kl1);
   string=['Rozdzielczosc : ' num2str(j) 'x' num2str(k)];
   set(findobj('tag','tekst1'),'string',string,...
      'userdata',[j k]);
   set(findobj('tag','tekst6'),'visible','off');
   set(findobj('tag','tekst7'),'visible','off');
   cd(pathstary);
   
case 2,
   
   pathstary=pwd;
   [filename,pathname]=uigetfile('*.*','Wczytywanie drugiej klatki', 250, 250);
	if pathname==0,
	   return
	end
	cd(pathname);
	kl2=imread(filename);
   id=findobj('type','axes');
   set(1,'currentaxes',id(1));
   imagesc(kl2);
   colormap gray;
   axis off;
   set(id(1),'userdata',kl2);
   [j,k]=size(kl2);
   string=['Rozdzielczosc : ' num2str(j) 'x' num2str(k)];
   set(findobj('tag','tekst2'),'string',string,...
      'userdata',[j k]);
   cd(pathstary);
   
case 3,
   
   x=get(findobj('tag','tekst2'),'userdata');
   if isempty(x)==1,
      helpdlg('Brak wczytanych klatek','COS NIE TAK');
      return
   end
	dlg=inputdlg('Podaj ilosc blokow','Wybor ilosci blokow');
	if isempty(dlg)==1 | isempty(dlg{1})==1,
	   return,
	end
	il_blokow=str2num(dlg{1});
   if il_blokow<2,
      helpdlg('Zbyt mala ilosc blokow','COS NIE TAK');
      return
   elseif il_blokow<3,
      il_blokow_x=2;
      il_blokow_y=1;
   elseif il_blokow<4,
      il_blokow_x=3;
      il_blokow_y=1;
   elseif il_blokow<5,
      il_blokow_x=2;
      il_blokow_y=2;
   elseif il_blokow<7,
      il_blokow_x=3;
      il_blokow_y=2;
   elseif il_blokow<9,
      il_blokow_x=4;
      il_blokow_y=2;
   elseif il_blokow<11,
      il_blokow_x=3;
      il_blokow_y=3;
   elseif il_blokow<14,
      il_blokow_x=4;
      il_blokow_y=3;
   elseif il_blokow<17,
      il_blokow_x=4;
      il_blokow_y=4;
   elseif il_blokow<21,
      il_blokow_x=6;
      il_blokow_y=3;
   else,
      il_blokow_x=6;
      il_blokow_y=4;
   end
   il_blokow=il_blokow_x*il_blokow_y;
   set(findobj('tag','tekst3'),'string',num2str(il_blokow),'userdata',[il_blokow_x il_blokow_y]);
   
case 4,
   
	x=inputdlg('Podaj obszar poszukiwan','Wybor obszaru poszukiwan');
	if isempty(x)==1 | isempty(x{1})==1,
	   return,
	end
	obszar=str2num(x{1});
   set(findobj('tag','tekst4'),'string',x{1},'userdata',obszar);
   
case 5,
   
   rozmiar=get(findobj('tag','tekst3'),'userdata');
   if isempty(rozmiar)==1,
      helpdlg('Brak zdefiniowanej ilosci blokow','COS NIE TAK');
      return
   end
   obszar=get(findobj('tag','tekst4'),'userdata');
   if isempty(obszar)==1,
      helpdlg('Brak zdefiniowanego obszaru poszukiwan','COS NIE TAK');
      return
   end
   rozdzielczosc=get(findobj('tag','tekst1'),'userdata');
   rozdzielczosc1=get(findobj('tag','tekst2'),'userdata');
   if isempty(rozdzielczosc)==1 | isempty(rozdzielczosc1)==1,
      helpdlg('Brak wczytanych klatek','COS NIE TAK');
      return
   end
   if rozdzielczosc~=rozdzielczosc1,
      helpdlg('Rozne rozdzielczosci klatek','COS NIE TAK');
      return
   end
   dx=rozdzielczosc(2)/rozmiar(1);
   dy=rozdzielczosc(1)/rozmiar(2);
   id=findobj('type','axes');
   kl1=get(id(2),'userdata');
   kl2=get(id(1),'userdata');
   if isempty(kl1)==1 | isempty(kl2)==1,
      helpdlg('Wczytaj ponownie klatki','COS NIE TAK');
      return
   end
   metoda=get(findobj('tag','tekst5'),'userdata');
   if isempty(metoda)==1,
      helpdlg('Brak wybranej metody poszukiwan','COS NIE TAK');
      return
	elseif metoda==1,
      num=1;
   elseif metoda==2,
      num=2;
   else,
      helpdlg('Brak wybranej metody poszukiwan','COS NIE TAK');
      return
   end
   kl11=kl1;
   kl11(:,1:dx:end)=255;
   kl11(1:dy:end,:)=255;
   set(1,'currentaxes',id(2));
   imagesc(kl11);
   colormap gray;
   axis off;
   [w,k]=size(kl1);
   suma_kl1=[];
   wsp_blokow=[];rozn_klatek=[];
   switch num,
   case 1,
      
	   for i=0:rozmiar(1)-1,
	      x=1+i*dx;
	      for j=0:rozmiar(2)-1,
	         wskaznik1=255*dx*dy;
	         y=1+j*dy;
	         suma1=sum(sum(kl1(y:y+dy-1,x:x+dx-1)));
	         x1=x-obszar;
	         x2=x1+dx-1+2*obszar;
	         if x1<1, x1=1;end
	         if x2>rozdzielczosc(2), x2=rozdzielczosc(2);end
	         y1=y-obszar;
	         y2=y1+dy-1+2*obszar;
	         if y1<1, y1=1;end
	         if y2>rozdzielczosc(1), y2=rozdzielczosc(1);end
	         for m=0:x2-x1-dx+1,
	            wsp_x=x1+m;
	            for n=0:y2-y1-dy+1,
	               wsp_y=y1+n;
	               suma2=sum(sum(kl2(wsp_y:wsp_y+dy-1,wsp_x:wsp_x+dx-1)));
	               wskaznik2=abs(suma1-suma2);
	               if wskaznik2<wskaznik1, wskaznik1=wskaznik2; xblok=wsp_x;yblok=wsp_y; end
	            end   
            end   	
            rozn_klatek=[rozn_klatek; wskaznik1];
	         wsp_blokow=[wsp_blokow; xblok yblok]; 
	      end
      end
      
   case 2,
      
	   for i=0:rozmiar(1)-1,
	      x=1+i*dx;
	      for j=0:rozmiar(2)-1,
	         wskaznik1=255*dx*dy;
	         y=1+j*dy;
	         suma1=sum(sum(kl1(y:y+dy-1,x:x+dx-1)));
	         x1=x-obszar;
	         x2=x1+dx-1+2*obszar;
	         if x1<1, x1=1;end
	         if x2>rozdzielczosc(2), x2=rozdzielczosc(2);end
            y1=y;
            y2=y1+dy-1;
	         if y2>rozdzielczosc(1), y2=rozdzielczosc(1);end
	         for m=0:x2-x1-dx+1,
	            wsp_x=x1+m;
               suma2=sum(sum(kl2(y1:y2,wsp_x:wsp_x+dx-1)));
               wskaznik2=abs(suma1-suma2);
               if wskaznik2<wskaznik1, wskaznik1=wskaznik2; xblok=wsp_x;yblok=y1; end
            end 
	         x1=x;
	         x2=x1+dx-1;
	         if x2>rozdzielczosc(2), x2=rozdzielczosc(2);end
	         y1=y-obszar;
	         y2=y1+dy-1+2*obszar;
	         if y1<1, y1=1;end
	         if y2>rozdzielczosc(1), y2=rozdzielczosc(1);end
            for n=0:y2-y1-dy+1,
               wsp_y=y1+n;
               suma2=sum(sum(kl2(wsp_y:wsp_y+dy-1,x1:x2)));
               wskaznik2=abs(suma1-suma2);
               if wskaznik2<wskaznik1, wskaznik1=wskaznik2; xblok=x1;yblok=wsp_y; end
            end 
            rozn_klatek=[rozn_klatek; wskaznik1];
	         wsp_blokow=[wsp_blokow; xblok yblok]; 
	      end
      end
   end   
   il_blokow=length(wsp_blokow);
   for i=1:il_blokow,
      xp=wsp_blokow(i,1);
      yp=wsp_blokow(i,2);
      kl2(yp:yp+dy,xp)=255;
      kl2(yp:yp+dy,xp+dx)=255;
      kl2(yp,xp:xp+dx)=255;
      kl2(yp+dy,xp:xp+dx)=255;
   end
   set(1,'currentaxes',id(1));
   imagesc(kl2);
   colormap gray;
   axis off;
   set(findobj('tag','tekst6'),'userdata',rozn_klatek);
   set(findobj('tag','tekst7'),'userdata',wsp_blokow);
   
case 6,
   
   metoda=questdlg('Wybierz metode przeszukiwania','Wybor metody',...
      'Pelne','Logarytmiczne','Pelne');
   if strcmp(metoda,'Pelne')==1,
      set(findobj('tag','tekst5'),'string','Przeszukiwanie pelne',...
         'userdata',1);
   else,
      set(findobj('tag','tekst5'),'string','Przeszukiwanie logarytmiczne',...
         'userdata',2);
   end
   
case 7,
   
   wsp_blokow=get(findobj('tag','tekst7'),'userdata');
   rozn_klatek=get(findobj('tag','tekst6'),'userdata');
   if isempty(wsp_blokow)==1 | isempty(rozn_klatek)==1,
      helpdlg('Brak wykonania programu','COS NIE TAK');
      return
   end
   info=questdlg('Wybierz rodzaj informacji','Wybor informacji',...
      'Wspolrzedne blokow','Przesunieta roznica klatek','Wspolrzedne blokow');
   if strcmp(info,'Wspolrzedne blokow')==1,
      set(findobj('tag','tekst7'),'visible','on','string','Wspolrzedne blokow');
      rozmiar=get(findobj('tag','tekst3'),'userdata');
      rozdzielczosc=get(findobj('tag','tekst1'),'userdata');
	   dx=rozdzielczosc(2)/rozmiar(1);
      dy=rozdzielczosc(1)/rozmiar(2);
      wsp_blokow1=[1:dy:rozdzielczosc(1)]';
      wsp_blokow2=[1:dx:rozdzielczosc(2)]';
      g=length(wsp_blokow2);
      h=length(wsp_blokow1);
      wsp=[];
      for i=1:g,
         for k=1:h,
            wsp=[wsp; [wsp_blokow2(i) wsp_blokow1(k)]];
         end
      end
      przes=wsp_blokow-wsp;
	   set(findobj('tag','tekst6'),'visible','on','string',num2str([wsp przes]));
   else,
      set(findobj('tag','tekst7'),'visible','on','string','Przesunieta roznica klatek wynosi');
      set(findobj('tag','tekst6'),'visible','on','string',num2str(rozn_klatek));
   end
   
end   
   










